package com.mikhaellopez.androidwebserver.service;

import com.mikhaellopez.androidwebserver.utils.StringUtils;

import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

public class ArgumentProvider {
    public static JSONObject map2json(Map<String,String> maps){
        return new JSONObject();
    }

    public static Map<String,String> json2map(JSONObject jsonObject){
        return new HashMap<>();
    }

    public static String map2query(Map<String,String> map){
        if (map == null) {
            return "";
        }
        StringBuilder sb = new StringBuilder();
        if (map.size() > 0) {
            for (String key : map.keySet()) {
                sb.append(key).append("=");
                if (StringUtils.isEmpty(map.get(key))) {
                    sb.append("&");
                } else {
                    Object object = map.get(key);
                    String value = object.toString();
                    System.out.println(value);
                    sb.append(value).append("&");
                }
            }
        }
        return sb.toString();
    }

    /**
     * 将url参数转换成map
     * @param param aa=11&bb=22&cc=33
     * @return
     */
    public static Map<String, Object> getUrlParams(String param) {
        Map<String, Object> map = new HashMap<String, Object>(0);
        if (StringUtils.isEmpty(param)) {
            return map;
        }
        String[] params = param.split("&");
        for (int i = 0; i < params.length; i++) {
            String[] p = params[i].split("=");
            if (p.length == 2) {
                map.put(p[0], p[1]);
            }
        }
        return map;
    }

    /**
     * 将map转换成url
     * @param map
     * @return
     */
    public static String getUrlParamsByMap(Map<String, Object> map) {
        if (map == null) {
            return "";
        }
        StringBuffer sb = new StringBuffer();
        for (Map.Entry<String, Object> entry : map.entrySet()) {
            sb.append(entry.getKey() + "=" + entry.getValue());
            sb.append("&");
        }
        String s = sb.toString();
        if (s.endsWith("&")) {
            s = StringUtils.substringBefore(s, "&");
        }
        return s;
    }

}
