package com.mikhaellopez.androidwebserver.service;

public class WiFiService {
    /**
     * setWifiEnabled
     added in API level 1
     public boolean setWifiEnabled (boolean enabled)
     Enable or disable Wi-Fi.

     Applications must have the Manifest.permission.CHANGE_WIFI_STATE permission to toggle wifi.

     Parameters
     enabled	boolean: true to enable, false to disable.
     Returns
     boolean	false if the request cannot be satisfied; true indicates that wifi is either already in the requested state, or in progress toward the requested state.
     Throws
     java.lang.SecurityException} if the caller is missing required permissions.
     startLocalOnlyHotspot
     added in API level 26
     public void startLocalOnlyHotspot (WifiManager.LocalOnlyHotspotCallback callback,
     Handler handler)
     Request a local only hotspot that an application can use to communicate between co-located devices connected to the created WiFi hotspot. The network created by this method will not have Internet access. Each application can make a single request for the hotspot, but multiple applications could be requesting the hotspot at the same time. When multiple applications have successfully registered concurrently, they will be sharing the underlying hotspot. WifiManager.LocalOnlyHotspotCallback.onStarted(LocalOnlyHotspotReservation) is called when the hotspot is ready for use by the application.

     Each application can make a single active call to this method. The WifiManager.LocalOnlyHotspotCallback.onStarted(LocalOnlyHotspotReservation) callback supplies the requestor with a WifiManager.LocalOnlyHotspotReservation that contains a WifiConfiguration with the SSID, security type and credentials needed to connect to the hotspot. Communicating this information is up to the application.

     If the LocalOnlyHotspot cannot be created, the WifiManager.LocalOnlyHotspotCallback.onFailed(int) method will be called. Example failures include errors bringing up the network or if there is an incompatible operating mode. For example, if the user is currently using Wifi Tethering to provide an upstream to another device, LocalOnlyHotspot will not start due to an incompatible mode. The possible error codes include: WifiManager.LocalOnlyHotspotCallback.ERROR_NO_CHANNEL, WifiManager.LocalOnlyHotspotCallback.ERROR_GENERIC, WifiManager.LocalOnlyHotspotCallback.ERROR_INCOMPATIBLE_MODE and WifiManager.LocalOnlyHotspotCallback.ERROR_TETHERING_DISALLOWED.

     Internally, requests will be tracked to prevent the hotspot from being torn down while apps are still using it. The WifiManager.LocalOnlyHotspotReservation object passed in the WifiManager.LocalOnlyHotspotCallback.onStarted(LocalOnlyHotspotReservation) call should be closed when the LocalOnlyHotspot is no longer needed using WifiManager.LocalOnlyHotspotReservation.close(). Since the hotspot may be shared among multiple applications, removing the final registered application request will trigger the hotspot teardown. This means that applications should not listen to broadcasts containing wifi state to determine if the hotspot was stopped after they are done using it. Additionally, once WifiManager.LocalOnlyHotspotReservation.close() is called, applications will not receive callbacks of any kind.

     Applications should be aware that the user may also stop the LocalOnlyHotspot through the Settings UI; it is not guaranteed to stay up as long as there is a requesting application. The requestors will be notified of this case via WifiManager.LocalOnlyHotspotCallback.onStopped(). Other cases may arise where the hotspot is torn down (Emergency mode, etc). Application developers should be aware that it can stop unexpectedly, but they will receive a notification if they have properly registered.

     Applications should also be aware that this network will be shared with other applications. Applications are responsible for protecting their data on this network (e.g., TLS).

     Applications need to have the following permissions to start LocalOnlyHotspot: Manifest.permission.CHANGE_WIFI_STATE and ACCESS_COARSE_LOCATION. Callers without the permissions will trigger a SecurityException.
     * */
}
